#include <stdio.h>
#include <string.h>

#include <X11/Intrinsic.h>
#include <X11/keysym.h>

#include "dftype.h"
#include "dfxfunc.h"

static int idx;
static const DfCmdStr *cand;
static const DfCmdStr *CmdTab;

extern int mod_keys;


void CmdReset(void)
{
  idx = 0;
  cand =CmdTab;
}

void CmdSetTable(const DfCmdStr *tab)
{
  CmdTab = tab;
  CmdReset();
}

int CmdTypeAhead(KeySym c)
{
  const DfCmdStr *cur;
  int n;

  if(mod_keys == cand->key[idx].mod && cand->key[idx].k == c){
    idx++;
    if(cand->key[idx].k == '\0'){
      /* found */
      idx = 0;
      return cand->cmd;
    }
    /* continue */
    return 0;
  }

  /* find next candidate */
  n = 0;
  cur = cand;
  for(;;){
    do{
      if(0 < idx && memcmp(cur->key + n, cand->key, idx) != 0){
	goto skip;
      }
      if(mod_keys == cand->key[idx].mod && cand->key[idx].k == c){
	idx++;
	if(cand->key[idx].k == '\0'){
	  idx = 0;
	  return cand->cmd;
	}
	return 0;
      }
skip:
      cand++;
      if(cand->key == NULL){
	cand = CmdTab;
      }
    }while(cand != cur);
    if(idx == 0){
      break;
    }
    idx--;
    n++;
  }

  idx = 0;
  return 0;
}

