#include <sys/types.h>
#include <sys/stat.h>
#include <dirent.h>
#include <unistd.h>

typedef enum{
  DS_NONE,/* normal.*/
    DS_WAIT_DIR,/* wait for file listing in directory */
    DS_WAIT_FOP,/* wait for file operation(copy, remove...) */
    DS_WAIT_NET,/* wait for network connection */
    DS_WAIT_DIALOG,/* when popup dialog */
    DS_BUSY,
}df_stat;

/* dialog operation */
typedef enum{
  DO_COPY,
  DO_MOVE,
  DO_RENAME,
  DO_DELETE,
  DO_ATTR,
  DO_LINK,
}df_opcode;

/* basic structure */
typedef struct _dfList DfList;
struct _dfList{
  DfList *prev;
  DfList *next;
};

typedef struct _dfVerb{
  int (*activate)(void *);
  int (*keybd_event)(void *, Widget, KeySym, Boolean *);
  int (*draw)(void *, Display *, Widget, GC);
  int (*free)(void *);
}DfVerb;

typedef struct _dfBuf DfBuf;
struct _dfBuf{
  DfList list;
  DfBuf *parent;
  DfBuf *active;
  int visible;
  XRectangle rc;
  const DfVerb *v;
};

/* structure for filer */
typedef struct _dfFile{
  char *pszName;
  mode_t attr;
  int color;
  off_t size;
  uid_t owner;
  gid_t group;
  time_t atime;
  time_t mtime;
  time_t ctime;
  int nSelect;
}DfFile;

typedef struct _dfFileList DfFileList;
typedef struct _dfWindow DfWindow;

struct _dfWindow{
  DfBuf *lists;
  DfBuf *active;
  Widget w;
  int nBuf;
  int width;
  int height;
  int fClipping;
  XRectangle clip;
};

struct _dfFileList{
  DfBuf b;
  DfFile *files;
  df_stat stat;
  int nCur;
  int nStart;
  int nFiles;
  int nSelects;
  char *pszCurDir;
  char *pszFilenames;
};


struct _dfCandList{
  DfFile *files;
  df_stat stat;
  int nCur;
  int nStart;
  int nFiles;
  int nSelects;
  char *pszCurDir;
  char *pszFilenames;
};

typedef struct _dfDialog{
  DfBuf *list;
  Widget shell;
  df_opcode op;
  int (*invoke)(void *);
  char *cwd;
  char *files;
}DfDialog;

typedef struct _dfStr{
  char *str;
  int len;/* used length of strings */
  int alloced_len;/*  allocated length */
}DfStr;

typedef struct _dfCmdKey{
  int mod;
  KeySym k;
}DfCmdKey;
#define DFMOD_ALT      0x0100
#define DFMOD_CTRL     0x0200
#define DFMOD_SHIFT    0x0400
#define DFMOD_MASK     0xFF00
#define DFMOD_KEYMASK  0x00FF

typedef struct _dfCmdStr{
  DfCmdKey *key;
  int cmd;
}DfCmdStr;


extern DfWindow *dfx;
extern XFontSet vFontSet;
extern int vnFontHeight;
extern int vnFontBase;
enum{
  COLOR_BK,
  COLOR_FILE,
  COLOR_DIR,
  COLOR_LINK,
  COLOR_RO,
  COLOR_X,
  COLOR_DEV,
  COLOR_OTHER,
  COLOR_CURFG,
  COLOR_CURBG,
  COLOR_SELFG,
  COLOR_SELBG,
  COLOR_MARK,
  COLOR_MAX
};
extern int colors[COLOR_MAX];


