/* dfx function declare */
/* filer window */
void Wnd_Create(Widget parent, int cx, int cy);
void Wnd_Initialize(Widget w, DfWindow *wnd);

void FL_Init(DfFileList *list);


/*
 * strings
 */
int Str_Init(DfStr *s);
int Str_InitStr(DfStr *s, const char *str);
int Str_InitPsz(DfStr *s, const char *str);
int Str_Free(DfStr *s, int fFree);
char *Str_Get(DfStr *s);
int Str_Length(DfStr *s);
void Str_SetLength(DfStr *s, int len);
int Str_Add(DfStr *s, const char *str);
int Str_AddNUL(DfStr *s, const char *str);
int Str_AddChar(DfStr *s, char ch);
int Str_Overwrite(DfStr *s, int idx, const char *str);
int Str_Shrink(DfStr *s);
int Str_RegPath(DfStr *s);
char *Str_Dup(DfStr *s);

/*
 * directories
 */
int GetFiles(DfFileList *pList, const char *new_dir);


/*
 * utility
 */
int IsAbsPath(const char *path);
int IsEndSlash(DfStr *path);
void SetLastSlash(DfStr *path);
void AddRect(XRectangle *rc, int x, int y, int width, int height);
int MakeSelectList(DfStr *s, DfFileList *list);
unsigned long xAllocColor(Display *d, const char *color);
char *FindLastChar(char *p, char c);
void InvalidateWindow(Widget w);
void InvalidateRect(Widget w, XRectangle *rc);

void *NextBuffer(void *buf);
void *PrevBuffer(void *buf);
void ListClear(void *ptr);
void *ListAdd(void *a, void *b);
void *ListDel(void *a);

int RectIsOverlap(XRectangle *a, XRectangle *b);
void RectAdd(XRectangle *a, XRectangle *b);
void RectSub(XRectangle *a, XRectangle *b);

/* key commands */
void CmdReset(void);
void CmdSetTable(const DfCmdStr *tab);
int CmdTypeAhead(KeySym c);


#if MEMDEBUG
#define bMalloc(A) dbgMalloc(A, __FILE__, __FUNCTION__, __LINE__)
#define bReAlloc(A,B) dbgReAlloc(A,B,__FILE__, __FUNCTION__, __LINE__)
#define bFree(A) dbgFree(A,__FILE__, __FUNCTION__, __LINE__)
void *dbgMalloc(int size, const char *file, const char *func, int line);
void *dbgReAlloc(void *ptr, int size, const char *file, const char *func, int line);
void dbgFree(void *ptr, const char *file, const char *func, int line);
void DumpMemInfo(void);
void MemModInfo(void *ptr, const char *file, const char *func, int line);

#define Str_Init(S) dbgStr_Init(S, __FILE__, __FUNCTION__, __LINE__)
#define Str_InitStr(S,T) dbgStr_InitStr(S, T, __FILE__, __FUNCTION__, __LINE__)
#define Str_Add(S, T) dbgStr_Add(S, T, __FILE__, __FUNCTION__, __LINE__)
#define Str_AddNUL(S, T) dbgStr_AddNUL(S, T, __FILE__, __FUNCTION__, __LINE__)
#define Str_AddChar(S, C) dbgStr_AddChar(S, C, __FILE__, __FUNCTION__, __LINE__)
#define Str_Overwrite(S, N, T) dbgStr_Overwrite(S,N, T,  __FILE__, __FUNCTION__, __LINE__)
#define Str_Shrink(S) dbgStr_Shrink(S, __FILE__, __FUNCTION__, __LINE__)
#define Str_Dup(S) dbgStr_Dup(S, __FILE__, __FUNCTION__, __LINE__)

int dbgStr_Init(DfStr *s, const char *file, const char *func, int line);
int dbgStr_InitStr(DfStr *s, const char *str, const char *file, const char *func, int line);
int dbgStr_Add(DfStr *s, const char *str, const char *file, const char *func, int line);
int dbgStr_AddNUL(DfStr *s, const char *str, const char *file, const char *func, int line);
int dbgStr_AddChar(DfStr *s, char ch, const char *file, const char *func, int line);
int dbgStr_Overwrite(DfStr *s, int idx, const char *str, const char *file, const char *func, int line);
int dbgStr_Shrink(DfStr *s, const char *file, const char *func, int line);
char *dbgStr_Dup(DfStr *s, const char *file, const char *func, int line);
#else
#define bMalloc(A) malloc(A)
#define bReAlloc(A,B) realloc(A,B)
#define bFree(A) free(A)
#endif
