#include <stdio.h>
#include <stdlib.h>
#include <signal.h>

#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>
#include <X11/keysym.h>
#include <X11/Shell.h>
#include <X11/Xaw/Form.h>
#include <X11/Xaw/AsciiText.h>

#include "dftype.h"
#include "dfxfunc.h"

Widget vDlgShell;
Widget vDialog;
Widget vText;

static void wndKeyProc(Widget w, XtPointer p, XEvent *event, Boolean *cont);


int ShowDialog(Widget parent)
{

  if(!vDlgShell){
    vDlgShell = XtVaCreatePopupShell("dlg", transientShellWidgetClass, parent, NULL);
    vDialog = XtVaCreateManagedWidget("dialog", formWidgetClass, vDlgShell, NULL);
    vText = XtVaCreateManagedWidget("text", asciiTextWidgetClass, vDialog,
				    XtNeditType, XawtextEdit,
				    XtNstring, "test",
				    NULL);
    XtAddEventHandler(vDialog, KeyPressMask, False, wndKeyProc, vDlgShell);
    XtAddEventHandler(vText,   KeyPressMask, False, wndKeyProc, vDlgShell);
  }

  XtPopup(vDlgShell, XtGrabNonexclusive);
  XtSetKeyboardFocus(vDialog, vText);

  return 0;
}
static void wndKeyProc(Widget w, XtPointer p, XEvent *event, Boolean *cont)
{
  XKeyEvent *ev;
  KeySym k;

  ev = (XKeyEvent*)event;
  k = XLookupKeysym(ev, 0);
  switch(k){
  case XK_Escape:
    *cont = False;
    XtPopdown((Widget)p);
    break;
  }
}
