#include <stdio.h>
#include <string.h>

struct _TypeCmd{
  const char *key;
  const char *cmd;
};

typedef struct _TypeCmd TypeCmd;

TypeCmd CmdTab[] = {
  {"c", "copy"},
  {"pppk", "PPPK"},
  {"pppp", "PPPP"},
  {"pk", "PK"},
  {"kk", "KK"},
  {"gpk", "G+P+K"},
  {"mkd", "Make Directory"},
  {"mkf", "Make File"},
  {"del", "Delete"},
  {"r", "Rename"},
  {"exit", "Exit"},
  {NULL, NULL}
};

TypeCmd *TypeAhead(char c)
{
  static int idx;
  static TypeCmd *cand;
  TypeCmd *cur;
  int n;

  if(idx == 0){
    idx = 0;
    cur = CmdTab;
    cand = CmdTab;
  }
  printf("typed: %c\n", c);

  printf("%c cand: %s\n", c, cand->key);
  if(cand->key[idx] == c){
    idx++;
    if(cand->key[idx] == '\0'){
      /* found */
      idx = 0;
      return cand;
    }
    /* continue */
    return NULL;
  }

  /* find next candidate */
  n = 0;
  cur = cand;
  for(;;){
    printf("%d byte much.\n", idx);
    do{
      if(0 < idx && memcmp(cur->key + n, cand->key, idx) != 0){
	goto skip;
      }
      if(cand->key[idx] == c){
	idx++;
	if(cand->key[idx] == '\0'){
	  idx = 0;
	  return cand;
	}
	return NULL;
      }
skip:
      cand++;
      if(cand->key == NULL){
	cand = CmdTab;
      }
    }while(cand != cur);
    if(idx == 0){
      printf("no hit.\n");
      break;
    }
    idx--;
    n++;
  }

  idx = 0;
  return NULL;
}

TypeCmd *TypeStroke(const char *keys)
{
  TypeCmd *r;

  r = NULL;
  while(*keys){
    r = TypeAhead(*keys);
    keys++;
  }
  return r;
}

void test(void)
{
  TypeCmd *t;
  char buf[80];
  int n;

  do{
    fgets(buf, sizeof(buf), stdin);
    n = strlen(buf);
    if(buf[n - 1] == '\n'){
      buf[n - 1] = '\0';
    }
    t = TypeStroke(buf);
    if(t){
      printf("%s\n", t->cmd);
    }
  }while(!t || strcmp(t->cmd, "Exit"));
}

int main(void)
{
  test();
  return 0;
}
